#include "validation.h"

// In this file, you should validate the grammar of your input files.
// Any additional constraints mentioned in the problem statement should also be
// checked here.

// Please use the Validator class from the header for verifying the grammar.
// This automatically exits with code 43 (WA) when input parsing fails,
// and exits with code 42 when reading input and all tests succeeded.
// Please use v.WA("some ", "error ", "here ") to exit with code 43 manually.

// When your program crashes unexpectedly, or something weird is going on,
// please write some info to stderr and return anything different from 42
// and 43.

const int eusmaxn = 5000;
const int eusmaxx = 1e9L;

int main(int argc, char **argv) {
  InputValidator v;
  int n = v.read_long_long(1, eusmaxn);
  v.newline();
  for (int i = 0; i < n; i++) {
    v.read_long_long(0, eusmaxx);
    if (i != n - 1) v.space();
  }
  v.newline();
}
