#include <iostream>
#include <string>
#include <vector>
#include <utility>
#include <iomanip>
using namespace std;

int main() {
    int n;
    cin >> n;

    // days of month    j   f   m   a   m   j   j   a   s   o   n   d
    vector<int> dom = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
    vector<int> dom_accum(13, 0);
    for (int i = 1; i < 13; ++i)
        dom_accum[i] = dom_accum[i-1] + dom[i-1];

    int bapc = dom_accum[9] + 26 + 1;
    int first_day = 0;

    // days are numbered 0 --- 364
    vector<bool> taken(365, false);

    string fmt;
    for (int i = 0; i < n; ++i) {
        // ignore name
        cin >> fmt >> fmt;
        int m = stoi(fmt.substr(0, 2));
        int d0 = stoi(fmt.substr(3, 2));
        int d = dom_accum[m-1] + d0 - 1;
        taken[d] = true;
        if (first_day < d && d <= bapc) first_day = d;
    }

    int current_gap = 0;
    int best_gap = 0;
    int best_day = 0;
    for (int d = first_day; d < first_day + 2*365; ++d) {
        if (!taken[d % 365]) {
            current_gap++;
            if (current_gap > best_gap) {
                best_gap = current_gap;
                best_day = d % 365;
            }
        } else {
            current_gap = 0;
        }
    }

    int m = 0;
    for (; m < 13; ++m) {
        if (best_day < dom_accum[m]) break;
    }
    m--;
    best_day -= dom_accum[m];
    cout << setfill('0') << setw(2) << m+1 << '-' << setw(2) << best_day+1 << endl;
}