import sys

n = int(sys.stdin.readline())
p = 1000000009
a = sorted([int(x) for x in sys.stdin.readline().split()])

# perm[k][l] contains the number of distinct permutations of 
# a[k], ..., a[l-1].

perm = [[0]*(n+1) for _ in range(n+1)]
for k in range(n+1):
    perm[k][k] = 1
    ct = 0

    for l in range(k+1, n+1):

        if l > k + 1 and a[l-2] == a[l-1]:
            ct += 1
        else:
            ct = 1

        perm[k][l] = (perm[k][l - 1]*(l-k))//ct

eus = [0]*(n+1)
eus[0] = 1;

for k in range(1, n+1):
    # A k element sequence which is not entirely unsorted has a first
    # sorted element, and we count them by the position of that first
    # element. The elements before that are entirely unsorted, and the
    # elements after are in any order.
    #
    # Then we just subtract the unentirely unsorted sequences from all
    # sequences we can make out of the first k elements, to get the
    # entirely unsorted ones.

    eus[k] = perm[0][k]
    for i in range(k):
        eus[k] -= (eus[i] * perm[i+1][k])

print(eus[n] % p)
